// modern.h: interface for the modern class.
//
//////////////////////////////////////////////////////////////////////
#ifndef _MODERN_H
#define _MODERN_H
#include <stdbool.h>



//    ===== 第四章 近代平差 =====
//    ===== 第四章 近代平差 =====
//    ===== 第四章 近代平差 =====
//    ===== 第四章 近代平差 =====


//void Robust_Example();   //  抗差估计例题（独立）
//void CoRobust_Example();//  抗差估计例题（相关）

//void KalmanFilter_Example();

//void KalmanFilter_Example1();
//void KalmanFilter_Example2();
//void KalmanFilter_Example3();


//void DataSnooping_Example();   //  粗差探测例题

//    序贯平差例题
//void SuccessivExample();

//void SuccessivExample2();//用序贯平差法进行一般的参数平差

//void Adjust_With_PX_Example();



double DataSnooping(int n,int t,double A[],double L[],double P[],double eps,double m0,
					double X[], double N[],double V[],bool W[]);





double Robust( int n, int t,double A[],double L[],double P[],
			  int ff,double k0,double k1, double sigma, double eps,
			  double X[], double QX[], double V[],double W[]);

//	相关 robust 估计
double CoRobust( int n, int t,double A[],double L[],double P[],	           
		         int ff,double k0,double k1,double sigma,double eps ,
				double X[], double QX[], double V[],double W[]);


//序贯平差
double Successive_Adjustment( int n, int t, double A[],double L[],double P[],
							 double X[], double QX[],double V[]);



//参数加权平差
double Adjust_With_PX(int n,int t,int t1,bool correlative,
					  double A[], double L[], double P[],
					  double X1[],double PX1[],int Num[],
					  double X[], double Qx[] ,double V[]);
//卡尔曼滤波
bool KalmanFilter(int n,int t,double A[],double L[],double P[],
				  double F[],double QW[],double X[],double QX[]);

//半参数估计				  
bool  SemiParameter(int n,int t,double alpha,
					double A[],double P[],double L[],double R[],
					double X[],double QX[],double V[]);

// 岭估计					  
double Ridge(int n, int t,double A[],double L[],double P[],double k,
			 double X[],double QX[],double V[]);				  

// 半参数估计算例
//void SemiParameter_Example();
//void Ridge_Example();
			 
#endif // _MODERN_H
