
//
//////////////////////////////////////////////////////////////////////
#ifndef _PUBLIC_H
#define _PUBLIC_H


#include <stdio.h>
#include <stdbool.h>
#include <math.h>

//////////////////////////////////////////////////////////////////////////
//       对称矩阵下标计算函数

#define ik (i>=k)? i*(i+1)/2+k : k*(k+1)/2+i
#define kj (k>=j)? k*(k+1)/2+j : j*(j+1)/2+k

#define RADIAN_2_SECOND (3600.0*180.0*M_PI)   //when convert,Multiply it



//  权倒数计算函数
double Calculate_q(double *Q,double *F,int t);
//  权倒数计算函数
double Calculate_q_compressed(double Q[],double F[],int Fin[],int n);




//void MyBreak(char* fmt, ...);

int ij(int i,int j);



bool inverse(double a[],int n);

/*
bool inverse3(double A[],int n);
bool inverse4(double A[],int n);
*/


// 权逆阵传播计算
void Calculate_BQBT(double B[],double Q[],int r,int n,double N[]);



//  将度分秒连写的(double型)角度化为弧度值
double dms_rad(double a);

//  将角度的弧度值化为度分秒连写的角度（double 型） 
double rad_dms(double a);


void PrintM(FILE *fp,double A[],int size, int t,char* fmt,
			char* title, bool IsLabel);

void  PrintM2(FILE* fp, double M[], int n,int t,char *fmt,
			  char* title,bool IsLabel);

void  PrintEquation(FILE* fp, double A[], double b[],
					int n, int m,char *fmt,char* title);

#define IGG1  0
#define IGG3  1
#define Huber 2


double Wi(int fname, double v, double k0, double k1);

double Median(double pp[],int n,bool IsAbs);//中位数计算


#endif  //_PUBLIC_H
