// charpter1_main.c : Defines the entry point for the console application.
// very sorry，here is a file to test,so only in chinese


#include "stdio.h"
#include "public.h"
#include <malloc.h>
#include <libintl.h>
#define _(String) gettext (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)



#define GETTEXT_PACKAGE "charpter1"
#define LOCALEDIR "mo"

void main3_1()
{
	double A[]={1.0,2.0,3.0,4.0,5.5,6.6,7.7,8.8,9.9,0.0};
	FILE *fp=fopen("./算例/矩阵输出/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	PrintM(fp,A,10,2,"%8.3lf ","坐标",true);
	fclose(fp);
}			


//////////////////////////////////////////////////////////////////////////
//    对称矩阵输出算例
void main3_2()
{
	double A[]={1.0,0.0,2.0,-1.0,4.0,5.0};
	FILE *fp=fopen("./算例/对称矩阵输出/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	PrintM2(fp,A,3,3,"%8.3lf ","A矩阵",true);
	fclose(fp);
}			

//////////////////////////////////////////////////////////////////////////
//    线性方程输出算例
void main3_3()
{
	double A[]={1.0, 0.0,
		        2.0,-1.0,
				4.0,5.0};
	double b[]={ 1.0,2.0,3.0};
	
	FILE *fp=fopen("./算例/线性方程组输出/result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	PrintEquation(fp,A,b,3,2,"%8.3lf ","线性方程组");
	fclose(fp);
}			



//////////////////////////////////////////////////////////////////////////
//    对称正定矩阵求逆例题
void main_4()
{
	const int n=3;
	double *A=(double *)malloc(sizeof(double)*n*(n+1)/2);
	double B[]={ 	5.0, 
			1.0, 6.0, 
			-3.0, 1.0, 7.0};
	for(int j=0;j<n*(n+1)/2;j++)
	{
		A[j]=B[j];
	}			

	PrintM2(stdout,A,n,n,"%10.6lf","A矩阵",false);
	
	inverse(A,n);
	PrintM2(stdout,A,n,n,"%10.6lf","A之逆阵",false);

	return ;
}
		
//////////////////////////////////////////////////////////////////////////
//  权逆阵计算例题
void main_5()
{
	double QX[6]={ 2.0,
		          -1.0, 3.0,
				   0.5, 0.0, 4.2 };			
	double B[6]={ 1.0, 2.0, 3.0, 
		          4.0, 5.0, 6.0	};	
	double N[3];
	for(int i=0;i<3;i++) N[i]=0.0;
	FILE *fp=fopen("./算例/权逆阵传播/Result.txt","w");
	if(fp==NULL)
	{
		fprintf(stderr," 创建结果文件失败！\n");
		return;
	}
	PrintM2(fp,QX,3,3,"%8.3lf","QX",false);
	PrintM(fp,B,6,3,"%8.3lf","B",false);
	
	Calculate_BQBT(B,QX,2,3,N);
	PrintM2(fp,N,2,2,"%8.3lf","QY",false);
	return ;
}


//////////////////////////////////////////////////////////////////////////
//   权倒数计算例题
int main_6()
{
	double Q[10]={ 2.0,
				  -1.0, 3.0, 
				   0.5, 1.2, 4.0,
				   0.0, 1.3, 1.4,5.0 };			
	//第一种方法：
	double F[4]={ 1.0, 0.0, 0.5, 0.0};	
	double q=Calculate_q(Q,F,4);
	printf("\n第一种方法：q=%lf",q);
	
	//第二种方法：
	double FF[2]={ 1.0, 0.5};
	int Fin[2]={0,2};	
	q=Calculate_q_compressed( Q,FF,Fin,2);
	printf("\n第二种方法：q=%lf",q);
	return 0;
}


//////////////////////////////////////////////////////////////////////////
//  中位数计算例题
void main_7()
{
	double A[9]={5.0, -6.0,9.0,1.0,2.0,8.0, -3.0,4.0,7.0};
	double m=Median(A,9,true);
	printf("\n中位数（绝对值）:  m=%lf",m);			
	m=Median(A,9,false);
	printf("\n中位数:  m=%lf",m);			
}


//////////////////////////////////////////////////////////////////////////
//  角度值格式互换例题
int main_8()
{
	double A=330545.35;
	double B=455145.25;
	printf("\nA=%lf",A);
	printf("\nB=%lf",B);
	
	double AB=dms_rad(A)+dms_rad(B);
	printf("\nA+B=%lf",rad_dms(AB));
	
	printf("\n");
	return 0;	
}




int main(int argc, char* argv[])
{

	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
  	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  	textdomain (GETTEXT_PACKAGE);


	
	
	printf("\n     ===== 第一章 平差辅助函数算例 =====\n");
	printf("本章共有9个例题：\n");
	printf("	1.数组输出（1.3.1 例题）\n");
	printf("	2.对称矩阵输出（1.3.2 例题）\n");
	printf("	3.对称矩阵输出（1.3.2 例题）\n");
	printf("	4.矩阵求逆（1.3 例题）\n");
	printf("	5.权逆阵传播（1.5 例题）\n");
	printf("	6.权倒数计算（1.6 例题）\n");
	printf("	7.中位数计算（1.7 例题）\n");
	printf("	8.角度值格式互换（1.8 例题）\n");
	
	
	printf("\n请从键盘输入要执行的例题编号:");
	

	int sw=getc(stdin)-'0';

	switch(sw) 
	{
	case 1: 
		main3_1();	
		break;
	case 2:
		main3_2(); 
		break;
	case 3:
		main3_3();	
		break;
	case 4:
		main_4(); 
		break;
	case 5:
		main_5(); 
		break;
	case 6:
		main_6(); 
		break;
	case 7:
		main_7(); 
		break;
	case 8:
		main_8(); 
		break;
		
	default:

		break;
	}
	
	printf("\n");
	
	return 0;
}



























