// 
//
//////////////////////////////////////////////////////////////////////

#ifndef _CLASSIC_H
#define _CLASSIC_H

//    ＝＝＝ 经典平差，  经典平差 ＝＝＝
//    ＝＝＝ 经典平差，  经典平差 ＝＝＝
//    ＝＝＝ 经典平差，  经典平差 ＝＝＝
//    ＝＝＝ 经典平差，  经典平差 ＝＝＝


#include <math.h>
#include <stdio.h>
#include <stdbool.h>


//        参数平差（观测值独立）
double Adjust(int n,int t, double A[],double L[],double p[],
			  double X[],double N[],double V[]);

//void Adjust_Example() ; //     参数平差例题（观测值独立）


//          观测值相关的参数平差
double Co_Adjust(int n, int t,double A[],double L[],double p[],
				 double X[], double N[],double V[]);

//         条件平差
double Condition(int n, int r,double B[],double W[],double P[],
				 double Q[],double V[]);

//     条件平差(观测值相关),
//     Q－调用前是观测权逆阵，调用后是平差值的权逆阵
double Co_Condition(int n, int r,double B[],double W[],double Q[],double V[]);


//     具有条件的参数平差

double Adjust_With_Constraint(int n, int t,int r,bool correlative,
			double A[],double L[],double B[],double W[],double P[],
			double X[],double QX[],double V[]);

//        具有条件的参数平差 算例
//void Adjust_With_Constraint_Example();



//         具有参数的条件平差
double Condition_With_X(int n, int r,int t,bool correlative,
						double B[],double Bx[],double W[],double P[],
						double X[],double QX[],double V[]);
//    具有参数的条件平差 算例
void Condition_With_X_Example();

//void Co_Adjust_Example();//     参数平差例题（观测值咱相关）




//void Condition_Example(); // 条件平差 例题

//void Co_Condition_Example(); //相关条件平差 算例




#endif // _CLASSIC_H
